<!-- Nav -->
<%- include('partials/nav', {active: "containers"}); %>

<div class="container-fluid">
    <div class="row d-flex d-md-block flex-nowrap wrapper">
        <main class="col-12 float-left col px-5 px-md-3 py-3 main">
            <h1 class="display-3 hidden-xs-down">
                Dashboard
            </h1>
            <% include ./partials/messages %>
            <div class="my-3 p-3 bg-white rounded shadow-sm">
                <h6 class="border-bottom border-gray pb-2 mb-0">Containers</h6>
                <div class="table-responsive">
                    <table class="table table-striped table-hover">
                        <thead class="thead-dark">
                            <tr>
                                <th scope="col">#</th>
                                <th scope="col">Id</th>
                                <th scope="col">Train ID</th>
                                <th scope="col">Name</th>
                                <th scope="col">Image</th>
                                <th scope="col">State</th>
                                <th scope="col">Status</th>
                                <th scope="col" class="w-operations-btn">Operations</th>
                            </tr>
                        </thead>
                        <tbody>
                            <% for(var i=0; i < containers.length; i++) { %>
                            <tr>
                                <th scope="row"><%= i+1 %></th>
                                <td><%= containers[i].Id.substring(0, 13) %></td>
                                <td class="break-word w-40vw font-weight-bold"><%= containers[i].TrainClassId %></td>
                                <td class="break-word w-15vw"><%= containers[i].Name %></td>
                                <td class="break-word w-20vw"><%= containers[i].Image %></td>
                                <td><%= containers[i].State %></td>
                                <td><%= containers[i].Status %></td>
                                <td>
                                    <% if(containers[i].State === "exited"){ %>
                                        <a href="<%='/docker/container/commit?container=' + containers[i].Id.substring(0, 13) + '&repo=' + containers[i].Repo + '&tag=' +containers[i].NextTag + '&image=' + containers[i].Image + '&jobId=' + containers[i].JobId %>"
                                        class="btn btn-primary my-2 my-sm-0 btn-block" >Commit</a>
                                    <a href="<%='/docker/container/remove?container=' + containers[i].Id.substring(0, 13) + '&jobId=' + containers[i].JobId %>"
                                        class="btn btn-danger my-2 my-sm-0 btn-block">Remove</a>
                                    <button onclick="showLogsModal('<%= containers[i].Id.substring(0, 13) %>')" 
                                        class="btn btn-secondary my-2 my-sm-0 btn-block">Logs</button>
                                    <button onclick="showContainerChangesModal('<%= containers[i].Id.substring(0, 13) %>', '<%= containers[i].JobId %>')" 
                                        class="btn btn-info my-2 my-sm-0 btn-block">Changes</button>
                                    <% } else if (containers[i].State === "running"){ %>
                                    <% } else{ %> 
                                    <a href="<%='/docker/container/start?container=' + containers[i].Id.substring(0, 13) + '&jobId=' + containers[i].Name%>"
                                        class="btn btn-primary my-2 my-sm-0 btn-block">Start</a>
                                        <a href="<%='/docker/container/remove?container=' + containers[i].Id.substring(0, 13) + '&jobId=' + containers[i].JobId %>"
                                        class="btn btn-danger my-2 my-sm-0 btn-block">Remove</a>
                                    <% } %>
                                </td>
                            </tr>
                            <% } %>
                        </tbody>
                    </table>
                </div>
            </div>

        </main>
    </div>
</div>

<div class="modal fade" id="logsModal" tabindex="-1" role="dialog" aria-labelledby="logsModalLabel" aria-hidden="true"
    data-backdrop="static">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="logsModalLabel">Container Logs</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <pre id="logsContent" style="max-height:60vh;">
                    <!--LOGS-->
                </pre>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="containerChangesModal" tabindex="-1" role="dialog" aria-labelledby="containerChangesModalLabel" aria-hidden="true"
    data-backdrop="static">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="containerChangesModalLabel">Container Changes</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-header border-bottom-0">
                <div class="row">
                    <div class="col">
                        <kbd class="bg-warning">Modified</kbd>
                    </div>
                    <div class="col">
                        <kbd class="bg-success">Added</kbd>
                    </div>
                    <div class="col">
                        <kbd class="bg-danger">Deleted</kbd>
                    </div>
                </div>
            </div>
            <div class="modal-body" style="max-height:60vh; overflow-y: auto;">

                <nav>
                    <div class="nav nav-tabs" id="nav-tab" role="tablist">
                      <a class="nav-item nav-link active" id="nav-list-tab" data-toggle="tab" href="#nav-change-list" role="tab" aria-controls="nav-change-list" aria-selected="true">List</a>
                      <a class="nav-item nav-link" id="nav-compare-tab" data-toggle="tab" href="#nav-change-compare" role="tab" aria-controls="nav-change-compare" aria-selected="false">Compare</a>
                    </div>
                </nav>
                <div class="tab-content" id="nav-tabContent">
                    <div class="tab-pane fade show active" id="nav-change-list" role="tabpanel" aria-labelledby="nav-change-list-tab">
                        <div id="treeView" class="container tree-view-container mt-2"></div>
                    </div>
                    <div class="tab-pane fade" id="nav-change-compare" role="tabpanel" aria-labelledby="nav-change-compare-tab">
                        <div id="compareView" class="container mt-2">
                            <h2 id="compareViewLoading">Analyzing <i class="fas fa-spinner fa-pulse"></i></h2>
                            <h1 id="compareViewFail" class="d-none">Something went wrong <i class="fas fa-times"></i></h1>
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>

<script>
    function showLogsModal(containerId) {
        $.get(`/docker/container/logs?container=${containerId}`, function (data) {
            try {
                data = JSON.parse(data);
            } catch (e) {
                alert("error");
                location.reload();
                return;
            }
            $('#logsModal').find('#logsContent').html(data);
            $('#logsModal').modal('show')
        });
    }

    function showContainerChangesModal(containerId, jobId) {

        // TREE VIEW TAB
        $.get(`/docker/container/changes?container=${containerId}`, function (data) {

            try {
                data = JSON.parse(data);
            } catch (e) {
                alert("error");
                location.reload();
                return;
            }

            let rootUl = document.createElement('ul');

            if (data && data.length)
                rootUl.appendChild(traversePathTree(data[0]));
            console.log(rootUl);

            $('#containerChangesModal').find('#treeView').html(rootUl);
            $('#containerChangesModal').modal('show')
        }).fail(function (error) {
            console.log(error);
            alert("An error occurred while loading the changes.");
        });

        // COMPARE TAB
        $.get(`/docker/container/compare?container=${containerId}&jobId=${jobId}`, function (diffHtml) {

            $('#containerChangesModal').find('#compareView').html(diffHtml);

        }).fail(function (error) {
            console.log(error);
            alert("An error occurred in the comparison.");

            $('#containerChangesModal').find('#compareViewLoading').addClass("d-none");
            $('#containerChangesModal').find('#compareViewFail').removeClass("d-none");
        });

        $("#containerChangesModal").on("hidden.bs.modal", function(){
            $('#containerChangesModal').find('#treeView').html("");
            $('#containerChangesModal').find('#compareView').html(`<h2 id="compareViewLoading">Analyzing <i class="fas fa-spinner fa-pulse"></i></h2><h1 id="compareViewFail" class="d-none">Something went wrong <i class="fas fa-times"></i></h1>`);

        });
    }

    function traversePathTree(node) {
        //process current node here
        let li = document.createElement('li');
        let a = document.createElement('a');
        a.href = `/docker/container/archive?container=${node.containerId}&path=${node.path}`;
        // a.download = `${node.containerId}_${node.path.replaceAll("/","_")}.tar`
        a.append(node.name);

        //visit children of current
        if (node.children.length) {

            let span = document.createElement('span');
            span.innerHTML = `<i class="fas fa-angle-down"></i> <i class="fas fa-folder text-${getKindColor(node.kindCode)}"></i> `;
            span.append(a);
            li.appendChild(span);

            let ul = document.createElement('ul');
            for (var index in node.children) {
                let childItem = traversePathTree(node.children[index]);
                ul.appendChild(childItem);
            }

            li.appendChild(ul);
        }
        else {
            let span = document.createElement('span');
            span.innerHTML = `<i class="fas fa-file text-${getKindColor(node.kindCode)}"></i> `;
            span.append(a);
            li.appendChild(span);

        }

        return li;
    }

    function getKindColor(kind) {
        switch (kind) {
            //Modified
            case 0:
                return 'warning'
                break;
            //Added
            case 1:
                return 'success'
                break;
            //Deleted
            case 2:
                return 'danger'
                break;
        }
    }
</script>